package MiCopyFicheros;

import java.io.*;

public class MiCopyFicheros {

    public static void main(String[] args) throws IOException {

    	//Tenemos los directorios y ficheros a copiar (origen)
        final String directory = "C:\\Users\\jandr\\Desktop\\Acceso a datos\\Container Ficheros\\";
        File f = new File(directory + "Fich_Origen_0410.bin");

        //Creamos los FIS y tambien decimos a donde mandar el nuevo archivo
        FileInputStream in = new FileInputStream(f);
        FileOutputStream out = new FileOutputStream(directory + "Fich_Destino_0410");

        //Empezamos la copia, si no esta vacio - null
        if (in != null) {

            System.out.println("\n> Empezando copia ...");

            int c;
            
            for (int i = 0; i <= 200; i = i + 20) {
            	
            	//Invocamos al metodo
                progressPercentage(i, 200);
                
                //Copiamos
				try {
					while ((c = in.read()) != -1) {
					    out.write(c);
					}
				} catch (IOException e1) {
					//Ignora
				}
				
                //Ralentizamos el output
                try {
                    Thread.sleep(1000);
                } catch (InterruptedException e) {
                    throw new RuntimeException(e);
                }
                
            }

            System.out.println("\n+ Se ha finalizado la copia correctamente");

        }

        //Cerramos los lectores
        in.close();
        out.close();

    }

    /**
     * Muestra el porcentaje del progreso [0/100%]
     */
    private static void progressPercentage(int remain, int total) {

    	//Si lo restante supera al total, lanzaremos excepcion
        if (remain > total)
            throw new IllegalArgumentException();

        //Generamos los atributos in-class
        int maxSize = 10, remaining = calcProgress(remain, total, maxSize);
        char notDone = '-';
        String done = "■", bare = new String(new char[maxSize]).replace('\0', notDone) + "]", bareDone = "[",
        		bareRemain = bare.substring(remaining, bare.length());;

        for (int i = 0; i < remaining; i++)
            bareDone += done;

        //Imprimimos el resultado
        System.out.print("\r" + bareDone + bareRemain + " " + remaining * 10 + "%");

    }

    /**
     * Calculo del progreso
     */
    private static int calcProgress(int remain, int total, int maxBareSize) {
        return ((100 * remain) / total) / maxBareSize;
    }
    
}
